<template>
  <div>
    <el-card class="box-card">
      <el-tabs v-model="activeName" type="card" @tab-change="changeActiveName">
        <el-tab-pane label="盘点单" name="first">
          <byTable
            :source="sourceList.data"
            :pagination="sourceList.pagination"
            :config="config"
            :loading="loading"
            :searchConfig="searchConfig"
            highlight-current-row
            :action-list="[
              {
                text: '盘点登记',
                action: () => clickModal(),
              },
            ]"
            @get-list="getList"
            @clickReset="clickReset">
          </byTable>
        </el-tab-pane>
        <el-tab-pane label="盘点明细" name="second">
          <byTable
            :source="sourceListTwo.data"
            :pagination="sourceListTwo.pagination"
            :config="configTwo"
            :loading="loading"
            :searchConfig="searchConfigTwo"
            highlight-current-row
            :action-list="[
              {
                text: '盘点登记',
                action: () => clickModal(),
              },
            ]"
            @get-list="getListTwo"
            @clickReset="clickResetTwo">
            <template #quantity="{ item }">
              <div>{{ calculationNum(item) }}</div>
            </template>
            <template #money="{ item }">
              <div>{{ calculationMoney(item) }}</div>
            </template>
          </byTable>
        </el-tab-pane>
      </el-tabs>
    </el-card>
  </div>
</template>

<script setup>
import byTable from "/src/components/byTable/index";

const { proxy } = getCurrentInstance();
const activeName = ref("first");
const departmentList = ref([{ dictKey: "0", dictValue: "胜德体育" }]);
const status = ref([
  { dictKey: "0", dictValue: "正常" },
  { dictKey: "1", dictValue: "异常" },
]);
const sourceList = ref({
  data: [],
  pagination: {
    total: 0,
    pageNum: 1,
    pageSize: 10,
    departmentId: "",
    warehouseName: "",
    status: "",
    beginTime: "",
    endTime: "",
  },
});
const sourceListTwo = ref({
  data: [],
  pagination: {
    total: 0,
    pageNum: 1,
    pageSize: 10,
    bomSpecCode: "",
    bomSpecName: "",
    departmentId: "",
    warehouseName: "",
    status: "",
    beginTime: "",
    endTime: "",
  },
});
const loading = ref(false);
const searchConfig = computed(() => {
  return [
    {
      type: "select",
      prop: "departmentId",
      data: departmentList.value,
      label: "事业部",
    },
    {
      type: "input",
      prop: "warehouseName",
      label: "仓库名称",
    },
    {
      type: "select",
      prop: "status",
      data: status.value,
      label: "盘点结果",
    },
    {
      type: "date",
      propList: ["beginTime", "endTime"],
      label: "盘点日期",
    },
  ];
});
const searchConfigTwo = computed(() => {
  return [
    {
      type: "input",
      prop: "bomSpecCode",
      label: "品号",
    },
    {
      type: "input",
      prop: "bomSpecName",
      label: "品名",
    },
    {
      type: "select",
      prop: "departmentId",
      data: departmentList.value,
      label: "事业部",
    },
    {
      type: "input",
      prop: "warehouseName",
      label: "仓库名称",
    },
    {
      type: "select",
      prop: "status",
      data: status.value,
      label: "盘点结果",
    },
    {
      type: "date",
      propList: ["beginTime", "endTime"],
      label: "盘点日期",
    },
  ];
});
const config = computed(() => {
  return [
    {
      attrs: {
        label: "盘点时间",
        prop: "createTime",
        width: 160,
        align: "center",
      },
    },
    {
      attrs: {
        label: "归属事业部",
        prop: "departmentName",
        "min-width": 160,
      },
    },
    {
      attrs: {
        label: "仓库类型",
        prop: "warehouseType",
        width: 140,
      },
      render(val) {
        return proxy.dictKeyValue(val, proxy.useUserStore().allDict["warehouse_type"]);
      },
    },
    {
      attrs: {
        label: "仓库名称",
        prop: "warehouseName",
        "min-width": 200,
      },
    },
    {
      attrs: {
        label: "入库类型",
        prop: "status",
        width: 140,
      },
      render(val) {
        return proxy.dictKeyValue(val, status.value);
      },
    },
    {
      attrs: {
        label: "盘点人",
        prop: "checkTaker",
        width: 160,
        align: "center",
      },
    },
  ];
});
const configTwo = computed(() => {
  return [
    {
      attrs: {
        label: "品号",
        prop: "bomSpecCode",
        width: 160,
      },
    },
    {
      attrs: {
        label: "品名",
        prop: "bomSpecName",
        "min-width": 220,
      },
    },
    {
      attrs: {
        label: "结存单价",
        prop: "balanceUnitPrice",
        width: 140,
        algin: "right",
      },
    },
    {
      attrs: {
        label: "仓库名称",
        prop: "warehouseName",
        width: 160,
      },
    },
    {
      attrs: {
        label: "归属事业部",
        prop: "departmentName",
        width: 160,
      },
    },
    {
      attrs: {
        label: "单位",
        prop: "bomUnit",
        width: 140,
      },
    },
    {
      attrs: {
        label: "盘前数量",
        prop: "surplusStock",
        width: 140,
      },
    },
    {
      attrs: {
        label: "盘后数量",
        prop: "checkQuantity",
        width: 140,
      },
    },
    {
      attrs: {
        label: "盘盈/亏数量",
        slot: "quantity",
        width: 140,
      },
    },
    {
      attrs: {
        label: "盘盈/亏金额",
        slot: "money",
        width: 140,
      },
    },
    {
      attrs: {
        label: "备注",
        slot: "remark",
        width: 140,
      },
    },
  ];
});
const getList = async (req, status) => {
  if (status) {
    sourceList.value.pagination = {
      pageNum: sourceList.value.pagination.pageNum,
      pageSize: sourceList.value.pagination.pageSize,
    };
  } else {
    sourceList.value.pagination = { ...sourceList.value.pagination, ...req };
  }
  loading.value = true;
  proxy.post("/check/page", sourceList.value.pagination).then((res) => {
    sourceList.value.data = res.rows;
    sourceList.value.pagination.total = res.total;
    setTimeout(() => {
      loading.value = false;
    }, 200);
  });
};
getList();
const clickReset = () => {
  getList("", true);
};
const getListTwo = async (req, status) => {
  if (status) {
    sourceListTwo.value.pagination = {
      pageNum: sourceListTwo.value.pagination.pageNum,
      pageSize: sourceListTwo.value.pagination.pageSize,
    };
  } else {
    sourceListTwo.value.pagination = { ...sourceListTwo.value.pagination, ...req };
  }
  loading.value = true;
  proxy.post("/checkBom/page", sourceListTwo.value.pagination).then((res) => {
    sourceListTwo.value.data = res.rows;
    sourceListTwo.value.pagination.total = res.total;
    setTimeout(() => {
      loading.value = false;
    }, 200);
  });
};
const clickResetTwo = () => {
  getListTwo("", true);
};
const changeActiveName = (val) => {
  if (val === "first") {
    getList();
  } else {
    getListTwo();
  }
};
const getDemandData = () => {
  proxy.post("/department/page", { pageNum: 1, pageSize: 999 }).then((res) => {
    if (res.rows && res.rows.length > 0) {
      departmentList.value = departmentList.value.concat(
        res.rows.map((item) => {
          return {
            dictKey: item.id,
            dictValue: item.name,
          };
        })
      );
    }
  });
};
getDemandData();
const clickModal = () => {
  proxy.$router.replace({
    path: "/check/add",
    query: {
      random: proxy.random(),
    },
  });
};
const calculationNum = (row) => {
  let num = 0;
  if (row.checkQuantity) {
    num = Number(row.checkQuantity);
  }
  if (row.surplusStock) {
    num = Number(num) - Number(row.surplusStock);
  }
  return num;
};
const calculationMoney = (row) => {
  let num = 0;
  if (row.checkQuantity) {
    num = Number(row.checkQuantity);
  }
  if (row.surplusStock) {
    num = Number(num) - Number(row.surplusStock);
  }
  if (row.balanceUnitPrice) {
    money = Number(Math.round(money * Number(row.balanceUnitPrice) * 100) / 100);
    return money;
  } else {
    return 0;
  }
};
</script>

<style lang="scss" scoped>
::v-deep(.el-input-number .el-input__inner) {
  text-align: left;
}
</style>
